<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
  {
    field: 'pkid',
    label: '序号',
    component: 'Input',
    hidden: true
  },{
    field: 'taskType',
    label: '类别',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'initOrganId',
    label: '发起督办机构id',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'accpetOrganId',
    label: '接受督办机构id',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'initDate',
    label: '发起督办时间',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'replyDate',
    label: '回复时间',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'status',
    label: '督办状态',
    component: 'Select',
    componentProps: {
      
    },
  },
  {
    field: 'taskContent',
    label: '督办内容',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'replyContent',
    label: '恢复内容',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'dgType',
    label: '任务类型',
    component: 'Select',
    componentProps: {
      
    },
  },
  {
    field: 'accpetOrganname',
    label: '督办机构',
    component: 'Input',
    componentProps: {
      
    },
  }
])

const rules = reactive({
  
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

